function createTimer(_ref, step) {
  var update = _ref.update,
      render = _ref.render;

  if (step === void 0) {
    step = 1 / 120;
  }

  var frameId;
  var last = -1;
  var acc = 0;
  var tick = 0;

  function onFrame(time) {
    if (last >= 0) {
      acc = acc + (time - last) / 1000;

      while (acc > step) {
        update(step, ++tick);
        acc = acc - step;
      }
    }

    last = time;
    render();
    frameId = requestAnimationFrame(onFrame);
  }

  function start() {
    if (frameId) {
      return;
    }

    last = -1;
    frameId = requestAnimationFrame(onFrame);
  }

  function stop() {
    cancelAnimationFrame(frameId);
    frameId = NaN;
  }

  return {
    start: start,
    stop: stop
  };
}

export { createTimer };
//# sourceMappingURL=index.modern.js.map
